/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// GroupSyncType the model 'GroupSyncType'
type GroupSyncType string

// List of GroupSyncType
const (
	GROUPSYNCTYPE_SLAVE                   GroupSyncType = "Slave"
	GROUPSYNCTYPE_SLAVE_WITH_PLACEHOLDERS GroupSyncType = "SlaveWithPlaceholders"
	GROUPSYNCTYPE_MASTER                  GroupSyncType = "Master"
	GROUPSYNCTYPE_SYNC_ERROR              GroupSyncType = "SyncError"
	GROUPSYNCTYPE_NO_SYNC                 GroupSyncType = "NoSync"
)

// All allowed values of GroupSyncType enum
var AllowedGroupSyncTypeEnumValues = []GroupSyncType{
	"Slave",
	"SlaveWithPlaceholders",
	"Master",
	"SyncError",
	"NoSync",
}

func (v *GroupSyncType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := GroupSyncType(value)
	for _, existing := range AllowedGroupSyncTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid GroupSyncType", value)
}

// NewGroupSyncTypeFromValue returns a pointer to a valid GroupSyncType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewGroupSyncTypeFromValue(v string) (*GroupSyncType, error) {
	ev := GroupSyncType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for GroupSyncType: valid values are %v", v, AllowedGroupSyncTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v GroupSyncType) IsValid() bool {
	for _, existing := range AllowedGroupSyncTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to GroupSyncType value
func (v GroupSyncType) Ptr() *GroupSyncType {
	return &v
}

type NullableGroupSyncType struct {
	value *GroupSyncType
	isSet bool
}

func (v NullableGroupSyncType) Get() *GroupSyncType {
	return v.value
}

func (v *NullableGroupSyncType) Set(val *GroupSyncType) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupSyncType) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupSyncType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupSyncType(val *GroupSyncType) *NullableGroupSyncType {
	return &NullableGroupSyncType{value: val, isSet: true}
}

func (v NullableGroupSyncType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupSyncType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
